package com.pfe.www;

import android.annotation.SuppressLint;
import android.content.ContentResolver;

import java.sql.Date;
import java.text.SimpleDateFormat;

@SuppressLint("SimpleDateFormat")
public class SMS {

	public String name;
	public String number;
	public String body;
	public Date date;
	public boolean am; // True if date [7h - 19h]
	public boolean send; // True if send by user
	
	public SMS(String number, String date, String body, boolean send, ContentResolver cr) {
		super();
		
		this.number = number;
		this.body = body;
		this.send = send;
		
		setDate(date);
		setAm();
		setName(cr);
	}
	
	public SMS(String date) {		
		setDate(date);
	}
	
	private void setDate(String date) {
		long val = Long.parseLong(date);
        this.date = new Date(val);
	}
	
	public String getDate(){
		SimpleDateFormat df = new SimpleDateFormat("dd/MM/yy HH:mm");
		return df.format(date);
	}
	
	public String getHour(){
		SimpleDateFormat df = new SimpleDateFormat("HH");
		return df.format(date);
	}

	private void setAm () {
		SimpleDateFormat df = new SimpleDateFormat("HH");
		int dateHour = Integer.parseInt(df.format(date));
        if( dateHour > 7 && dateHour < 19 ) {
        	am = true;
        } else {
        	am = false;
        }
	}
	
	private void setName (ContentResolver cr) {
		ContactProvider cp = new ContactProvider();
        name = cp.getNameByNumber(cr, number);
	}
	
}
