package com.pfe.www;

import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.wifi.WifiManager;
import android.net.wifi.ScanResult;
import android.os.IBinder;
import android.provider.Settings;

import java.util.List;
import java.util.Date;

public class WifiDeviceService extends Service {

    private static String wifiSSID = "BlackSheepMirror";
    private boolean isWifiNear = false;
    private String androidId;
    private WifiManager wifiManager;
    private BroadcastReceiver wifiReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            JSONFactory jf = new JSONFactory();
            Sender sender;

            if(intent.getAction() == WifiManager.SCAN_RESULTS_AVAILABLE_ACTION) {
                List<ScanResult> scanResults = wifiManager.getScanResults();
                boolean isWifiNearNow = false;
                for(ScanResult scanResult : scanResults) {
                    if(scanResult.SSID.equals(wifiSSID)) {
                        isWifiNearNow = true;
                        break;
                    }
                }

                if( isWifiNearNow != isWifiNear ) {
                    if( isWifiNearNow )
                        sender = new Sender("http://petrumagdeleine.com/rest/addWifiDevice", jf.makeWifiDeviceJSON(new Date(), androidId));
                    else
                        sender = new Sender("http://petrumagdeleine.com/rest/removeWifiDevice", jf.makeWifiDeviceJSON(new Date(), androidId));
                    sender.post();
                    isWifiNear = isWifiNearNow;
                }
            }
            else if(intent.getAction() == WifiManager.WIFI_STATE_CHANGED_ACTION) {
                if(wifiManager.getWifiState() == WifiManager.WIFI_STATE_DISABLED) {
                    sender = new Sender("http://petrumagdeleine.com/rest/removeWifiDevice", jf.makeWifiDeviceJSON(new Date(), androidId));
                    sender.post();
                    isWifiNear = false;
                }
            }
        }
    };

    @Override
    public void onCreate() {
        androidId = Settings.Secure.getString(getApplicationContext().getContentResolver(), Settings.Secure.ANDROID_ID);
        wifiManager = (WifiManager)getSystemService(Context.WIFI_SERVICE);
        wifiManager.setWifiEnabled(true);
        this.registerReceiver(wifiReceiver, new IntentFilter(WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));
        this.registerReceiver(wifiReceiver, new IntentFilter(WifiManager.WIFI_STATE_CHANGED_ACTION));
        super.onCreate();
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        return super.onStartCommand(intent, flags, startId);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        wifiManager.setWifiEnabled(false);
    }
    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
        throw new UnsupportedOperationException("Not yet implemented");
    }
}
