<?php
    
	/* 
		Class script proceeding secured API
		/!\ keep same as query string and function name
		
		Ex: If the query string value rquest=getSMS Access modifiers doesn't matter but function should be
		     function getSMS(){
				 You code goes here
			 }
		Class will execute the function dynamically;
		
		usage :
		
		    $object->response(output_data, status_code);
			$object->_request	- to get santinized input 	
			
			output_data : JSON
			status_code : Send status message for headers
			
		I used the below table :
		
		CREATE TABLE IF NOT EXISTS `SMS` (
		  `_id` int(11) NOT NULL AUTO_INCREMENT,
		  `hour` tinyint(1),
		  PRIMARY KEY (`_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 	*/
	
	require_once("Rest.inc.php");
	
	class API extends REST {
	
		public $data = "";
		
		// Paramétrage BDD

		const DB_SERVER = "";
		const DB_USER = "";
		const DB_PASSWORD = "";
		const DB = "";
		
		private $db = NULL;
	
		public function __construct(){
			parent::__construct();				// Init parent contructor
			$this->dbConnect();					// Initiate Database connection
		}
		
		/*
		 *  Database connection 
		*/
		private function dbConnect(){
			$this->db = mysql_connect(self::DB_SERVER,self::DB_USER,self::DB_PASSWORD);
			if($this->db)
				mysql_select_db(self::DB,$this->db);
		}
		
		/*
		 * Public method for access api.
		 * This method dynmically call the method based on the query string
		 *
		 */
		public function processApi(){
			$func = strtolower(trim(str_replace("/","",$_REQUEST['rquest'])));
			if((int)method_exists($this,$func) > 0)
				$this->$func();
			else
				$this->response('',404);				// If the method not exist with in this class, response would be "Page not found".
		}
		
		/* 
		 *	Simple addSMS API
		 *  must be POST method
		 *  smslist : JSONArray[sms]
		 */
		
		// à refaire avec la méthode post et une liste de sms

		private function addSMS(){
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET"){
				$this->response('',406);
			}

			$smslist = 12;	// 	JSONArray

			// INSERT value of smslist
			if(!empty($smslist)){

				$sql = mysql_query("INSERT INTO `petrumagafpetru`.`SMS` (`_id`, `hour`) VALUES (NULL, '".$smslist."')", $this->db);
				$result = "OK";

				// If success everythig is good send header as "OK" and user details
				$this->response($this->json($result), 200);
			} else {
				// If invalid inputs "Bad Request" status message and reason
				$error = array('status' => "Failed", "msg" => "Invalid smslist");
				$this->response($this->json($error), 400);

			}
		}

		private function addSMSList(){
			// Cross validation if the request method is POST else it will return "Not Acceptable" status
			if($this->get_request_method() != "POST"){
				$this->response('',406);
			}
			
			if(!empty($this->_request)){
				$smslist = $this->_request['name'];
				$smslist = json_decode($smslist, true);

				$request = "DELETE FROM `petrumagafpetru`.`SMS` WHERE `SMS`.`android_id` = '".$smslist['android_id']."'";
				$sql = mysql_query($request, $this->db);

				//mysql_query("TRUNCATE TABLE `petrumagafpetru`.`SMS`");

				foreach ($smslist as &$value) {
					$sql = mysql_query("INSERT INTO `petrumagafpetru`.`SMS` (`_id`, `android_id`,`hour`) VALUES (NULL, '".$smslist['android_id']."','".$value."')", $this->db);
				}

				// If success everythig is good send header as "OK" and user details
				$this->response($this->json($result), 200);
	
			} else {
				// If invalid inputs "Bad Request" status message and reason
				$smslist = "empty";
				$error = array('status' => "Failed", "msg" => "Invalid : ".$smslist."");
				$this->response($this->json($error), 400);
			}

		}

        private function addWords() {

            if($this->get_request_method() != "POST") {
				$this->response('', 406);
			}
            
			if(!empty($this->_request)) {

				$words = utf8_encode($_POST['name']);
				$words = json_decode($words, true);
				$request = "DELETE FROM `petrumagafpetru`.`Words` WHERE `Words`.`android_id` = '".$words['android_id']."'";
				$sql = mysql_query($request, $this->db);
                $request = "INSERT INTO `petrumagafpetru`.`Words` (`_id`, `android_id`, `words`) VALUES (NULL, '".$words['android_id']."', '".utf8_decode($words['words'])."')";
				$sql = mysql_query($request, $this->db);
				$result = "OK";
				$this->response($this->json($result), 200);

			} else {
				$error = array('status' => 'Failed', 'msg' => 'Error Words list');
				$this->response($this->json($error), 400);
			}
        }

        private function getWords() {
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET") {
				$this->response('',406);
			}

			$android_id = (isset($_GET["android"])) ? $_GET["android"] : NULL;

			$request = "SELECT * FROM `petrumagafpetru`.`Words` WHERE `Words`.`android_id` = '".$android_id."'";
			$sql = mysql_query($request, $this->db);
			if(mysql_num_rows($sql) > 0) {
				$rlt = mysql_fetch_array($sql,MYSQL_ASSOC);
				$this->response(utf8_encode($rlt['words']), 200);
			} else {
				// If no records "No Content" status
				$this->response('',204);
			}
		}

		private function getSMS(){	
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET"){
				$this->response('',406);
			}

			$android_id = (isset($_GET["android"])) ? $_GET["android"] : NULL;

			$request = "SELECT * FROM `petrumagafpetru`.`SMS` WHERE `SMS`.`android_id` = '".$android_id."'";
			$sql = mysql_query($request, $this->db);

			if(mysql_num_rows($sql) > 0){
				$result = array();
				while($rlt = mysql_fetch_array($sql,MYSQL_ASSOC)){
					$result[] = $rlt;
				}

				// If success everythig is good send header as "OK" and return list of SMS in JSON format
				$this->response($this->json($result), 200);
			} else {
				// If no records "No Content" status
				$this->response('',204);
			}
		}
		
		private function getAllSMS(){	
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET"){
				$this->response('',406);
			}

			$sql = mysql_query("SELECT * FROM `petrumagafpetru`.`SMS`", $this->db);

			//$sql = mysql_query("SELECT user_id, user_fullname, user_email FROM users WHERE user_status = 1", $this->db);
			
			if(mysql_num_rows($sql) > 0){
				$result = array();
				while($rlt = mysql_fetch_array($sql,MYSQL_ASSOC)){
					$result[] = $rlt;
				}
				// If success everythig is good send header as "OK" and return list of SMS in JSON format
				$this->response($this->json($result), 200);
			}
			$this->response('',204);	// If no records "No Content" status

			echo $result;
		}
		
		private function deleteAll(){
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET"){
			// if($this->get_request_method() != "DELETE"){
				$this->response('',406);
			}

			mysql_query("TRUNCATE TABLE `petrumagafpetru`.`SMS`");

			$sql = mysql_query("SELECT * FROM `petrumagafpetru`.`SMS`", $this->db);
			
			if(mysql_num_rows($sql) == 0){
				$success = array('status' => "Success", "msg" => "Successfully table cleared");
				$this->response($this->json($success),200);
			} else {
				$error = array('status' => "Failed", "msg" => "Error");
				$this->response($this->json($error), 400);
			}

			echo $result;
		}
        
        private function addLocation() {
            if($this->get_request_method() != "POST") {
				$this->response('', 406);
			}
            
			if(!empty($this->_request)) {
				$location = $this->_request['name'];
				$location = json_decode($location, true);
	
                $request = "INSERT INTO `petrumagafpetru`.`Location` (`_id`, `android_id`, `latitude`, `longitude`, `date`) VALUES (NULL, '".$location['android_id']."', '".$location['latitude']."', '".$location['longitude']."', '".$location['date']."')";
				$sql = mysql_query($request, $this->db);
				$result = "OK";

				$this->response($this->json($result), 200);
			} else {
				$error = array('status' => 'Failed', 'msg' => 'Error: addLocation');
				$this->response($this->json($error), 400);
			}
        }
        
        private function addWifiDevice() {
            if($this->get_request_method() != "POST") {
				$this->response('', 406);
			}
            
			if(!empty($this->_request)) {
				$device = $this->_request['name'];
				$device = json_decode($device, true);
	
                $request = "INSERT INTO `petrumagafpetru`.`WifiDevice` (`_id`, `android_id`, `date`) VALUES (NULL, '".$device['android_id']."', '".$device['date']."')";
				$sql = mysql_query($request, $this->db);
				$result = "OK";

				$this->response($this->json($result), 200);
			} else {
				$error = array('status' => 'Failed', 'msg' => 'Error: addWifiDevice');
				$this->response($this->json($error), 400);
			}
        }

        private function removeWifiDevice() {
            if($this->get_request_method() != "POST") {
				$this->response('', 406);
			}
            
			if(!empty($this->_request)) {
				$device = $this->_request['name'];
				$device = json_decode($device, true);
	
                $request = "DELETE FROM `petrumagafpetru`.`WifiDevice` WHERE `WifiDevice`.`android_id` = '".$device['android_id']."'";
				$sql = mysql_query($request, $this->db);
				$result = "OK";

				$this->response($this->json($result), 200);
			} else {
				$error = array('status' => 'Failed', 'msg' => 'Error: removeWifiDevice');
				$this->response($this->json($error), 400);
			}
        }
        
        private function getWifiDevices() {	
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET"){
				$this->response('',406);
			}

			$request = "SELECT * FROM `petrumagafpetru`.`WifiDevice`";
			$sql = mysql_query($request, $this->db);

			$result = array();
            while($rlt = mysql_fetch_array($sql, MYSQL_ASSOC)){
                $result[] = $rlt['android_id'];
            }
            $this->response($this->json($result), 200);
		}
        
        private function addContacts() {
            if($this->get_request_method() != "POST") {
				$this->response('', 406);
			}
            
			if(!empty($this->_request)) {
				$contacts = utf8_encode($this->_request['name']);
				$contacts = json_decode($contacts, true);
                
                $request = "DELETE FROM `petrumagafpetru`.`Contact` WHERE `Contact`.`android_id` = '".$contacts['android_id']."'";
				$sql = mysql_query($request, $this->db);
                foreach($contacts['conversations'] as $conversation) {
                    $request = "INSERT INTO `petrumagafpetru`.`Contact` (`_id`, `android_id`, `number`, `name`, `nb_sms`) VALUES (NULL, '".$contacts['android_id']."', '".$conversation['number']."', '".utf8_decode($conversation['name'])."', '".$conversation['sms_count']."');";
                    $sql = mysql_query($request, $this->db);
                }
                
				$result = "OK";
				$this->response($this->json($result), 200);
			} else {
				$error = array('status' => 'Failed', 'msg' => 'Error: addContacts');
				$this->response($this->json($error), 400);
			}
        }
        
        private function getContacts() {	
			// Cross validation if the request method is GET else it will return "Not Acceptable" status
			if($this->get_request_method() != "GET"){
				$this->response('',406);
			}

			$android_id = (isset($_GET["android"])) ? $_GET["android"] : NULL;

			$request = "SELECT * FROM `petrumagafpetru`.`Contact` WHERE `Contact`.`android_id` = '".$android_id."' AND `Contact`.`nb_sms` > 10";
			$sql = mysql_query($request, $this->db);

			if(mysql_num_rows($sql) > 0){
                // Generation of JSON
				$result = array(
                    "nodes" => array(
                        array(
                            "id" => "id0",
                            "name" => "Moi",
                            "artist" => $android_id,
                            "playcount" => 0,
                            "match" => 10
                        )
                    ),
                    "links" => array()
                );
                $i = 0;
				while($rlt = mysql_fetch_array($sql, MYSQL_ASSOC)){
					$result["nodes"][] = array(
                        "id" => "id".$rlt['_id'],
                        "name" => utf8_encode($rlt['name']),
                        "artist" => $rlt['number'],
                        "playcount" => (int)$rlt['nb_sms'],
                    );
                    $i += 0.1;
                    $result["links"][] = array(
                        "source" => "id0",
                        "target" => "id".$rlt['_id']
                    );
                    $result["nodes"][0]["playcount"] += (int)$rlt['nb_sms'];
				}
                
				$this->response($this->json($result), 200);
			} else {
				// If no records "No Content" status
				$this->response('',204);
			}
		}
		
		/*
		 *	Encode array into JSON
		*/
		private function json($data){
			if(is_array($data)){
				return json_encode($data);
			}
		}
	}
	
	// Initiiate Library
	
	$api = new API;
	$api->processApi();
?>
